# coding:utf-8

#计算风控结果

import re
class IndexComputer:
    funs=[]#公式集合
    def Init(self):
        return ""
    def Compute(self,indexItem):#计算单一指标
        print("================计算风控公式")
        # 如果所有因子有一个为空，返回数据不存在
        i = 0
        X = []
        Y = []
        V = {}
        S = []
        for factorkey in indexItem.FactorsValue:
            tempval = indexItem.FactorsValue[factorkey]
            if indexItem.FactorsValue[factorkey] is None:
                print("is None")
                return "0"
            try:
                eval(tempval)
            except:
                print("is isNumeric", indexItem.FactorsValue[factorkey])
                return "0"
            Y.append(float(indexItem.FactorsValue[factorkey]))
            V[factorkey] = str("Y[" + str(i) + "]")
            S.append(factorkey)
            i = i + 1
        S = sorted(S, key=lambda i: len(i), reverse=True)
        j = 0
        for fun in indexItem.Funs:
            print(indexItem.id,"===============gsid")
            funstr = fun
            for s in S:
                funstr = funstr.replace(s, str(V[s]))
            strinfo = re.compile(r'X\[\d*\]=')
            funstr = strinfo.sub("", funstr)
            try:
                print(funstr,"======funstr")
                val = eval(funstr)
                X.append(val)
                j = j + 1
            except ZeroDivisionError as err:
                print('Handling run-time error:', err)
                return "0"
            except(ValueError):
                print('other:', ValueError)
                return "0"
        if X[j - 1] == True:
            return "2"
        else:
            return "1"

    def finance_Compute(self, indexItem):
            finance_result = {}
            i = 0
            X = []
            Y = []
            V = {}
            S = []
            for factorkey in indexItem.FactorsValue:
                tempval = indexItem.FactorsValue[factorkey]
                print(factorkey,tempval,'===============factorkey,tempval')
                try:
                    eval(tempval)
                except Exception as e:
                    print(e, "======eval抛出财务异常")
                    return '—'
                Y.append(float(indexItem.FactorsValue[factorkey]))
                V[factorkey] = str("Y[" + str(i) + "]")
                S.append(factorkey)
                i = i + 1
            S = sorted(S, key=lambda i: len(i), reverse=True)
            j = 0
            for fun in indexItem.Funs:
                funstr = fun
                for s in S:
                    funstr = funstr.replace(s, str(V[s]))
                strinfo = re.compile(r'X\[\d*\]=')
                funstr = strinfo.sub("", funstr)
                try:
                    print("计算正常公式")
                    if type(funstr) == str:
                        val = eval(funstr)
                    else:
                        val = funstr
                    X.append(val)
                    j = j + 1
                except ZeroDivisionError as err:
                    print("计算异常公式时")
                    print('finance error:', err)
                    return "∞"
                Finance_result = int(X[j - 1])
                if Finance_result ==0.0:
                    Finance_result= int(Finance_result)
                else:
                    Finance_result=Finance_result
                return Finance_result